/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : May. 2007

 File          : PLA.c

 Hardware      : Applicable to ADuC702x rev H or I silicon
                 Currently targetting ADuC7028.

 Description   : start an ADC conversion if P1.2 and software enable
 				 P1.2 connected to DGND -> no ADC conversion
				 P1.2 high -> ADC conversion
				 ADCbusy on P0.5
		
*********************************************************************/
#include<aduc7028.h>

extern void plaInitialize(void);

void ADCpoweron(int);
void delay (int);

int main(void) {

	GP4DAT = 0x04000000;		// P4.2 configured as an output. LED is turned on	

	REFCON = 0x1;
	ADCpoweron(20000);			// power on ADC
	
	ADCCON = 0x4E5;				// configure ADC to convert on PLA signal
	           					// ADC Config: fADC/2, acq. time = 2 clocks => ADC Speed = 1MSPS
	
	GP0CON = 0x00100000; 		// Configure P0.5 as ADCbusy

	plaInitialize( );
	PLADIN = 0x0004;			// enable element 2  
	while (1)
	{
		GP4DAT ^= 0x00040000;		// Complement P4.2
		delay(200000);
	}				
}



 void delay (int length)
{
	while (length >=0)
    	length--;
}

void ADCpoweron(int time)
{
	ADCCON = 0x20;	 					// power-on the ADC
	while (time >=0)	  				// wait for ADC to be fully powered on
    time--;
}

